# Spec ArrayGaps
Stores length of gap- and non-gap runs in an array.

Extends | Gaps
All Extended | Gaps
All Impl'd | AssignableConcept, ContainerConcept, DestructibleConcept
Defined in | <seqan/align.h>
Signature | `template <typename TSequence> class Gaps<TSequence, ArrayGaps>`

## Template Parameters

`TSequence` | The type of the underling sequence.

## Member Function Overview

- `Gaps::Gaps([other]);, Gaps::Gaps(seq);`
  Constructor.

### Member Functions Inherited From AssignableConcept

- `operator=`

## Interface Function Overview

### Interface Functions Inherited From Gaps

- `assignSource`
- `beginPosition`
- `clearClipping`
- `clearGaps`
- `clippedBeginPosition`
- `clippedEndPosition`
- `clipSemiGlobal`
- `copyClipping`
- `copyGaps`
- `countCharacters`
- `countGapExtensions`
- `countGapOpens`
- `countGaps`
- `countLeadingGaps`
- `countTrailingGaps`
- `endPosition`
- `insertGap`
- `insertGaps`
- `isCharacer`
- `isGap`
- `iter`
- `length`
- `removeGap`
- `removeGaps`
- `setBeginPosition`
- `setClippedBeginPosition`
- `setClippedEndPosition`
- `setEndPosition`
- `source`
- `toSourcePosition`
- `toViewPosition`
- `unclippedLength`

### Interface Functions Inherited From AssignableConcept

- `assign`
- `set`
- `move`

### Interface Functions Inherited From ContainerConcept

- `writeValue`
- `write`
- `begin`
- `end`
- `length`
- `empty`
- `swap`
- `getObjectId`
- `moveValue`
- `append`
- `appendValue`
- `shrinkToFit`
- `directionIterator`

## Interface Metafunction Overview

### Interface Metafunctions Inherited From ContainerConcept

- `DefaultGetIteratorSpec`
- `DefaultIteratorSpec`
- `Difference`
- `DirectionIterator`
- `GetValue`
- `Iterator`
- `Position`
- `Reference`
- `Size`
- `Value`

## Member Functions Detail

### `Gaps::Gaps([other]); Gaps::Gaps(seq);`

Constructor.

#### Parameters

`other` | Other Gaps object to copy from.
`seq` | Sequence concept to construct the gaps for.

#### Data Races

Thread safety unknown!

#### Dox Sources

    /*!
     * @class ArrayGaps
     *
     * @extends Gaps
     *
     * @headerfile <seqan/align.h>
     *
     * @brief Stores length of gap- and non-gap runs in an array.
     *
     * @signature template <typename TSequence> class Gaps<TSequence, ArrayGaps>
     *
     * @tparam TSequence The type of the underling sequence.
     *
     * @fn ArrayGaps::Gaps
     *
     * @headerfile <seqan/align.h>
     *
     * @brief Constructor.
     *
     * @signature Gaps::Gaps([other]);
     * @signature Gaps::Gaps(seq);
     *
     * @param[in] other Other Gaps object to copy from.
     * @param[in] seq Sequence concept to construct the gaps for.
     */